import numpy as np
import matplotlib.pyplot as plt

performances = np.loadtxt("test.txt", delimiter=";", skiprows=1);

sizes = performances[:,0] / 10000
times = performances[:,1]

x = np.linspace(1, sizes[-1], np.size(sizes))

data3 = np.polyfit(sizes, times, 3)
p3 = np.poly1d(data3)
data4 = np.polyfit(sizes, times, 4)
p4 = np.poly1d(data4)
data5 = np.polyfit(sizes, times, 5)
p5 = np.poly1d(data5)

x1 = 1685.9236
x2 = 3166.3129
y1 = 1008.042130
y2 = 5133.954117

fig, ax = plt.subplots()

ax.scatter(sizes, times, c="green", marker='+', label="Raw data")
ax.set_title("Performance of the maze resolution algorithm for random squared mazes")
ax.set_xlabel("Size (in 10,000 of cells)")
ax.set_ylabel("Time (in ms)")

ax.plot(x, p3(x), c="black", label="Linear regression: degre 3")
ax.plot(x, p4(x), c="red", label="Linear regression: degre 4")
ax.plot(x, p5(x), c="magenta", label="Linear regression: degre 5")
plt.plot((x1, x2), (y1, y2), c="blue", label="Linear function")

ax.legend()


plt.show()