#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "maze.h"
#include "test.h"

void test_big_maze(void) {
    int width = 100;  // Set width for a large maze
    int height = 100; // Set height for a large maze

    printf("Initializing a %dx%d maze...\n", width, height);

    struct graph *maze = init_graph(width, height);
    if (!maze) {
        print_failure("Failed to initialize the maze.");
        return;
    }

    printf("Generating maze...\n");
    generate_maze(maze);

    printf("Solving maze...\n");
    struct vertex *exit_vertex = find_exit(maze, 0);
    if (!exit_vertex) {
        print_failure("Failed to find the exit in the maze.");
        free_graph(maze);
        return;
    }

    // Validate the path from start to exit
    struct vertex *current = exit_vertex;
    int steps = 0;

    while (current->id != 0) {
        current = current->parent;
        steps++;
    }

    printf("Maze solved in %d steps.\n", steps);
    print_success("The solution path is valid.");

    free_graph(maze);
}

int main(void) {
    srand(time(NULL));  // Seed for random number generation
    test_big_maze();
    return 0;
}
