#include <stdio.h>
#include "maze.h"
int test_bordure(struct vertex *const graph, int const width, int const height)
{
    if (graph == NULL || width < 1 || height < 1)
        return 0; // Test error if the graph is not initialized.

    int const size = width * height;

    // Check the first row (top == NULL)
    for (int i = 0; i < width; i++)
    {
        if (graph[i].top != NULL)
        {
            printf("Error: Cell %d (first row) has a non-NULL 'top'.\n", graph[i].id);
            return 0;
        }
    }

    // Check the last row (bottom == NULL)
    for (int i = size - width; i < size; i++)
    {
        if (graph[i].bottom != NULL)
        {
            printf("Error: Cell %d (last row) has a non-NULL 'bottom'.\n", graph[i].id);
            return 0;
        }
    }

    // Check the first column (left == NULL)
    for (int i = 0; i < size; i += width)
    {
        if (graph[i].left != NULL)
        {
            printf("Error: Cell %d (first column) has a non-NULL 'left'.\n", graph[i].id);
            return 0;
        }
    }

    // Check the last column (right == NULL)
    for (int i = width - 1; i < size; i += width)
    {
        if (graph[i].right != NULL)
        {
            printf("Error: Cell %d (last column) has a non-NULL 'right'.\n", graph[i].id);
            return 0;
        }
    }

    printf("The borders of the maze are correctly initialized.\n");
    return 1;
}

//------------------------------------------------------------------------------
/* Guide for the main
int main()
{
    int width = 5;
    int height = 4;
    int id_start = 0;

    struct vertex *graph = init_graph(width, height, id_start);

    if (graph != NULL)
    {
        int result = test_bordure(graph, width, height);
        if (result)
        {
            printf("The border test passed.\n");
        }
        else
        {
            printf("The border test failed.\n");
        }

        free_graph(graph);
    }
    else
    {
        printf("Error: Unable to initialize the graph.\n");
    }

    return 0;
}*/


