#include "maze.h"
#include "test.h"

#define WIDTH 1000
#define HEIGHT 1000

/*
 * Test if the first element is the start and the last element is the end.
 */
int test_start_and_end(struct vertex *const graph)
{
    if (graph == NULL)
        return 0;

    if (graph[0].is_start == 1 && graph[WIDTH * HEIGHT - 1].is_end == 1)
        return 1;

    return 0;
}

int main()
{
    struct vertex *graph = init_graph(WIDTH, HEIGHT, 0);

    if (graph == NULL)
    {
        print_failure("Failed to create a 1000x1000 maze.\n");
        return EXIT_FAILURE;
    }

    if (!test_start_and_end(graph))
    {
        print_failure("The start or end vertex is incorrect.\n");
        return EXIT_FAILURE;
    }

    print_success("The start and end vertices are correct.\n");

    free_graph(graph);

    return 0;
}
