#include "maze.h"
#include "test.h"

#define WIDTH 1000
#define HEIGHT 1000

/*
 * Test if there is exactly one exit.
 */
int test_unique_exit(struct vertex *const graph)
{
    if (graph == NULL)
        return 0;

    int exit_count = 0;
    for (int i = 0; i < WIDTH * HEIGHT; i++)
    {
        if (graph[i].is_end == 1)
            exit_count++;
    }

    return (exit_count == 1);
}

int main()
{
    struct vertex *graph = init_graph(WIDTH, HEIGHT, 0);

    if (graph == NULL)
    {
        print_failure("Failed to create a 1000x1000 maze.\n");
        return EXIT_FAILURE;
    }

    if (!test_unique_exit(graph))
    {
        print_failure("There is not exactly one exit.\n");
        return EXIT_FAILURE;
    }

    print_success("There is exactly one exit.\n");

    free_graph(graph);

    return 0;
}
