#include "maze.h"
#include <stdio.h>
#include "queue.h"
#include <time.h>
#include <fcntl.h>


int main(int argc, char *argv[]){
    if (argc != 6){
        printf("Usage: height, width, nbr of test, start, name of the file \n");
        exit(EXIT_FAILURE);
    }

    int const height = atoi(argv[1]);
    int const width = atoi(argv[2]);
    int const n = atoi(argv[3]); //the number of time we make the test
    int const start = atoi(argv[4]);
    int const size = height*width;
    struct graph *g;
    g = init_graph(width,height);
    if (g == NULL){
        printf("erreur lors de init_graph\n");
        exit(EXIT_FAILURE);
    }
    clock_t t_start, t_end;
    double result = 0;
    generate_maze(g);

    if(start <= 0 && start > size){
        printf("start pas dans le graphe\n");
        exit(EXIT_FAILURE);
    }

    // struct vertex *c = find_exit(g,start);
    for (int i = 0; i < n; i++){
        for (int j = 0; j < size; j++) {
            g->vertices[j].parent = NULL;
        }
        t_start = clock();
        (void)find_exit(g,start);
        t_end = clock();
        result += (((double)(t_end - t_start)/CLOCKS_PER_SEC)*1000); // the time in ms for each test
    }

    free_graph(g);

    //calculat the mean
    printf("la moyenne du temps prit pour la résolution est de : %f\n", result/n);

    FILE* file = fopen(argv[5], "a");
    //see if the file is empty for init the colum
    int empty = ftell(file);
    if (empty == 0){
        fprintf(file, "TIME SIZE\n");
    }
    fseek (file, 0, SEEK_END);
    fprintf(file, "%f %d\n", result/n, size);
    fclose(file);
    return 0;
}