#include <assert.h>
#include <stddef.h>
#include <stdlib.h>
#include <string.h>
#include <maze.h>
#include <test.h>
#define TYPE_TEST(x) _Generic((x), \
    int *: "int *", \
    void *: "void *")


void test_valeurs_negative() {
    struct vertex *graph = init_graph(-2, 10, 0);
    assert(graph == NULL); // the graph must be NULL if the width is negative

    if (graph == NULL) {
        print_success("Success : The graph is NULL for a width negative.\n");
    } else {
        print_failure("Failure : The graph is not NULL for a width negative.\n");
    }

    graph = init_graph(10, -2, 0);
    assert(graph == NULL);  // the graph must be NULL if the height is negative

    if (graph == NULL) {
        print_success("Success : The graph is NULL for a height negative.\n");
    } else {
        print_failure("Failure : The graph is not NULL for a height negative.\n");
    }

}

void test_types_valeurs(void *width, void *height) {
    if (strcmp(TYPE_TEST(width) ,"int *") == 0) {
        print_success("Success : The width is an integer.\n");
    } else {
        print_failure("Failure : The width is not an integer.\n");
    }
    if (strcmp(TYPE_TEST(height) ,"int *") == 0) {
        print_success("Success : The height is an integer.\n");
    } else {
        print_failure("Failure : The height is not an integer.\n");
    }
}

int main(int argc, char const *argv[]) {
    test_valeurs_negative();
    test_types_valeurs(&argv[1],&argv[2]);
    return 0;
}